#! /usr/bin/env python

# ==== NetT2Lin - Net-Tamer(MS-DOS)-to-Linux(Mutt/Pine) Mailbox Converter ====
# ============================================================================
# 
# 
# >>> Doc  in ENGlish  en FRAnais  in het NEDerlands >>> 
# 
# 
# 
# === ENG === 
# 
# This script was originally written in Python 
# April 2001 
# by Frederic Peters <fpeters@tiscalinet.be> 
#                    <http://gaby.sourceforge.net/> 
# 
# Documentation + translations (English, French, Dutch) 
# by Osvaldo La Rosa <olr@audiobraille.org> 
#                    VZW/ASBL Audio/Braille 
#                    <http://www.audiobraille.org/> / 
#                    <http://www.audiobraille.org/blinux/> 
# 
# Copyright(C) April 2001 - This package may be copied/redistributed 
# under the conditions described in the GNU General Public License. See 
# COPYING file. 
# 
# Contact the author for bug reports and if you'd like to contribute. 
# Contact the doc maintainer for remarks, corrections or your contribution. 
# 
# 
# Blind persons have been using MS-DOS for long years because of his easy 
# and commandline access. Many DOS users (not exclusively visually impaired) 
# were using the popular Internet and E-mail client called Net-Tamer: 
# the purpose of this script is to help you converting all your "old" 
# "mail???.dlu" files to a Linux-compatible format so that they can be read 
# by Mutt or Pine. 
# 
# Simply copy this script to the /usr/local/bin directory 
# and make it executable with chmod +x 
# then enter the command: 
# 
# nett2lin /mnt/dos_?/nettamer-dir/mail-dir/mail?.dlu > ~/Mail/destination 
# 
# IMPORTANT: this application requires Python; be sure it is already 
# installed before running nett2lin.py 
# 
# 
# 
# === FRA === 
# 
# Le prsent script  t crit en Python 
# Avril 2001 
# par Frederic Peters <fpeters@tiscalinet.be> 
#                     <http://gaby.sourceforge.net/> 
# 
# Documentation + traductions (Anglais, Franais, Nerlandais) 
# par Osvaldo La Rosa <olr@audiobraille.org> 
#                     VZW/ASBL Audio/Braille 
#                     <http://www.audiobraille.org/> / 
#                     <http://www.audiobraille.org/blinux/> 
# 
# Copyright(C) Avril 2001 - Le prsent package peut tre copi/redistribu 
# aux conditions dcrites dans la GNU General Public License. Cf. 
# fichier COPYING 
# 
# Contactez l'auteur pour signaler une anomalie ou si vous souhaitez 
# contribuer. 
# Contactez le responsable de la doc pour vos remarques, corrections ou
# votre contribution. 
# 
# 
# Les personnes non-voyantes ont utilis le MS-DOS durant de longues annes 
#  cause de son accs facile et en ligne de commande. 
# De nombreux utilisateurs DOS (pas exclusivement non-voyants) ont utilis le 
# populaire client Internet et courrier appel Net-Tamer: 
# le but du prsent script est de vous aider  convertir tous vos "vieux" 
# fichiers "mail????.dlu" en un format lisible sous Linux avec Mutt ou Pine. 
# 
# Copiez simplement ce script dans le rpertoire /usr/local/bin 
# et rendez-le excutable avec chmod +x 
# ensuite entrez la commande: 
# 
# nett2lin /mnt/dos_?/nettamer-dir/mail-dir/mail?.dlu > ~/Mail/destination 
# 
# IMPORTANT: la prsente application requiert Python; assurez-vous de 
# sa prsence sur votre systme avant d'utiliser nett2lin.py 
# 
# 
# 
# === NED === 
# 
# Dit script werd oorspronkelijk geschreven in Python 
# April 2001 
# door Frederic Peters <fpeters@tiscalinet.be> 
#                      <http://gaby.sourceforge.net/> 
# 
# Documentatie + vertalingen (Engels, Frans, Nederlands) 
# door Osvaldo La Rosa <olr@audiobraille.org> 
#                      VZW/ASBL Audio/Braille 
#                      <http://www.audiobraille.org/> / 
#                      <http://www.audiobraille.org/blinux/> 
# 
# Copyright(C) April 2001 - Dit pakket mag gekopierd/verspreid worden 
# onder de voorwaarden zoals omschreven in de GNU General Public License. 
# Zie COPYING bestand. 
# 
# Contacteer de auteur voor bug-meldingen en voor een eigen contributie. 
# Contacteer de doc houder voor opmerkingen, correcties of uw contributie. 
# 
# 
# Blinde mensen hebben jarenlang MS-DOS gebruikt vanwege zijn eenvoudige en 
# commandolijn-toegang. Vele DOS gebruikers (niet uitsluitend visueel 
# gehandicapten) gebruikten het populaire Internet en E-mail client genaamd 
# Net-Tamer: 
# het doel van dit script is U te helpen al uw "oude" "mail????.dlu" 
# mappen naar een Linux formaat om te zetten zodat zij gelezen kunnen worden 
# met behulp van Mutt of Pine. 
# 
# Kopier gewoon dit script naar de /usr/local/bin directory 
# en maak het uitvoerbaar met chmod +x 
# waarna je de opdracht geeft: 
# 
# nett2lin /mnt/dos_?/nettamer-dir/mail-dir/mail?.dlu > ~/Mail/destination 
# 
# BELANGRIJK: de huidige applicatie vereist Python; zorg ervoor dat het 
# aanwezig is op het systeem vooraleer U nett2lin.py gebruikt 
# 
# 
# 
# ============================================================================
# == end of documentation/fin de la documentation/einde van de documentatie ==

import sys
import rfc822
import string
import time

if len(sys.argv) <> 2:
	print 'Usage: nett2lin.py NETTamerMailbox > LINuxMailbox'
	sys.exit(1)

lines = open(sys.argv[1]).readlines()

lines = map(lambda x: x[:-2] + '\n', lines)

mails = []
first = 1
m = None
for l in lines:
	if l[:4] == '+OK ':
		if not first: mails.append(m)
		m = []
		first = 0
		continue
	if first: continue
	m.append(l)
mails.append(m)

for (m,i) in map(None, mails, range(len(mails))):
	try:
		lfrom = filter(lambda x: x[:5] == 'From:', m)[0]
	except:
		# malformed mail;
		continue
	ldate = filter(lambda x: x[:5] == 'Date:', m)[0]
	lfrom = filter(lambda x: '@' in x, string.split(lfrom))[0]
	if lfrom[0] == '<': lfrom = lfrom[1:-1]
	date = rfc822.parsedate(ldate[5:])
	print 'From', lfrom, time.strftime('%a %b %d %H:%M:%S %Y', date)
	sys.stdout.writelines(m[:-2])

